#!/usr/bin/perl

# ICO Resetter support routines
# Copyright (c) 2002 ICO Innovative Computer GmbH, Alexander P. Weber
# You should only change the following variables unless you know
# exactly what you are doing

# Variables 
$config_file = '/var/www/cgi-bin/resetter.conf';
do "$config_file";

%keytable = (
esc => 0x76,
f1 => 0x05,
f2 => 0x06,
f3 => 0x04,
f4 => 0x0c,
f5 => 0x03,
f6 => 0x0b,
f7 => 0x83,
f8 => 0x0a,
f9 => 0x01,
f10 => 0x09,
f11 => 0x78,
f12 => 0x07,
circ => 0x0e,
1 => 0x16,
2 => 0x1e,
3 => 0x26,
4 => 0x25,
5 => 0x2e,
6 => 0x36,
7 => 0x3d,
8 => 0x3e,
9 => 0x46,
0 => 0x45,
"_" => 0x4e,
"+" => 0x55,
"|" => 0x5d,
bs => 0x66,
tab => 0x0d,
q => 0x15,
w => 0x1d,
e => 0x24,
r => 0x2d,
t => 0x2c,
z => 0x35,
u => 0x3c,
i => 0x43,
o => 0x44,
p => 0x4d,
"[" => 0x54,
"]" => 0x5b,
caps => 0x58,
a => 0x1c,
s => 0x1b,
d => 0x23,
f => 0x2b,
g => 0x34,
h => 0x33,
j => 0x3b,
k => 0x42,
l => 0x4b,
":" => 0x4c,
"\"" => 0x52,
cr => 0x5a,
lshift => 0x12,
y => 0x1a,
x => 0x22,
c => 0x21,
v => 0x2a,
b => 0x32,
n => 0x31,
m => 0x3a,
"<" => 0x41,
">" => 0x41,
"?" => 0x4a,
rshift => 0x59,
ctrl => 0x14,
alt => 0x11,
space => 0x29,
del => 0x71,
ins => 0x70,
home => 0x6c,
end => 0x69,
pgup => 0x7d,
pgdn => 0x7a,
up => 0x75,
down => 0x72,
left => 0x6b,
right => 0x74,
dot => 0x49,
comma => 0x41,
"\n" => 0x5a,
"\r" => 0x5a,
home => 0xe06c,
"" => 0x4e,
"'" => 0x55,
);


# URLParse([&assoc], [methode])
# Parses CGI parameters or global in and stores the information in $in
sub URLParse
{
local $a = $_[0] ? $_[0] : \%in;
local $i;
local $meth = $_[1] ? $_[1] : $ENV{'REQUEST_METHOD'};
undef($in);
if ($meth eq 'POST') {
        read(STDIN, $in, $ENV{'CONTENT_LENGTH'});
        }
if ($ENV{'QUERY_STRING'}) {
        if ($in) { $in .= "&".$ENV{'QUERY_STRING'}; }
        else { $in = $ENV{'QUERY_STRING'}; }
        }
#&SendHeader();
#print "$in<br>\n";
@in = split(/\&/, $in);
foreach $i (@in) {
        local ($k, $v) = split(/=/, $i, 2);
        $k =~ s/\+/ /g; $k =~ s/%(..)/pack("c",hex($1))/ge;
        $v =~ s/\+/ /g; $v =~ s/%(..)/pack("c",hex($1))/ge;
        $a->{$k} = defined($a->{$k}) ? $a->{$k}."\0".$v : $v;
        }
}

# SendHeader
# Prints a generic HTTP header
sub SendHeader
{
print "pragma: no-cache\n" if ($pragma_no_cache || $config{'pragma_no_cache'});
if (defined($_[0])) {
        print "Content-type: text/html; Charset=$_[0]\n\n";
        }
else {
        print "Content-type: text/html\n\n";
        }
}

# SendRedirect
# uses Location: to redirect the users's browser to a given location
sub SendRedirect
{
local($port, $prot, $url);
$port = $ENV{'SERVER_PORT'} == 443 && uc($ENV{'HTTPS'}) eq "ON" ? "" :
        $ENV{'SERVER_PORT'} == 80 && uc($ENV{'HTTPS'}) ne "ON" ? "" :
                ":$ENV{'SERVER_PORT'}";
$prot = uc($ENV{'HTTPS'}) eq "ON" ? "https" : "http";
if ($_[0] =~ /^(http|https|ftp|gopher):/) {
        $url = $_[0];
        }
elsif ($_[0] =~ /^\//) {
        $url = "$prot://$ENV{'SERVER_NAME'}$port$_[0]";
        }
elsif ($ENV{'SCRIPT_NAME'} =~ /^(.*)\/[^\/]*$/) {
        $url = "$prot://$ENV{'SERVER_NAME'}$port$1/$_[0]";
        }
else {
        $url = "$prot://$ENV{'SERVER_NAME'}$port/$_[0]";
        }
print "Location: $url\n\n";
}


# html_escape
# Converts several characters to their HTML pendants
sub html_escape
{
local($tmp);
$tmp = $_[0];
$tmp =~ s/&/&amp;/g;
$tmp =~ s/</&lt;/g;
$tmp =~ s/>/&gt;/g;
$tmp =~ s/\"/&quot;/g; 
$tmp =~ s/\'/&#39;/g;
return $tmp;
}

# ListPorts()
# Lists all configured ports (aka jobs)
sub ListPorts
{
local(@rv, $_);
local(@rv, $_);
open (PORTS,$ports_file);
while (<PORTS>) {
 chop; s/;.*$//g; s/^\s*#.*$//g;
 if (/^\s*\[([^\]]+)\]/) {
  push(@liste,$1);
  }
 }
close(PORTS);
return(@liste);
}

# GetPort(portname,[array])
# Fetches all available information about the supplied port name and
# stores it in the assoiative array
sub GetPort
{
local ($found,$_,$first,$array);
$arr = (@_==2 ? $_[1] : "port");
undef(%$arr);
open (PORTS,$ports_file);
while (<PORTS>) {
 chop; s/^\s*;.*$//g; s/^\s*#.*$//g;
 if (/^\s*\[([^\]]+)\]/) {
  $first = 1;
  if ($found) { last; }
  elsif ($1 eq $_[0]) { $found = 1; $$arr{portname} = $1; }
  }
 elsif ($found && /^\s*([^=]*\S)\s*=\s*(.*)$/) {
  $$arr{lc($1)} = $2;
  }
 elsif (!$first && /^\s*([^=]*\S)\s*=\s*(.*)$/ && $_[0] eq "admin") {
  $$arr{portname} = "admin";
  $$arr{lc($1)} = $2;
  $found=1;
  }
 }
close(PORTS);
return($found);
}

# ReadValue(name)
# Reads and returns the value of config item "name" 
sub ReadValue
{
local($_);
if (defined($port{$_[0]})) {
 return $port{$_[0]};
 }
return undef;
}

# WriteValue(name, value)
# Sets the value of the config item "name" within the port array
# Does nothing if the old and new values are the same
sub WriteValue
{
local($_);
if ($port{$_[0]} ne $_[1]) {
 $port{$_[0]} = $_[1];
 }
}

# AddPort(portname)
# Adds an Entry to the ports file
sub AddPort
{
open (PORTS,">>$ports_file");
print PORTS "\n";
print PORTS "[$_[0]]\n";
foreach $i (grep {!/portname/} (keys %port)) {
 print PORTS "\t$i = $port{$i}\n";
 }
close (PORTS);
}

# ChangePort
# Changes Values inside a port section
sub ChangePort
{
local($_, @ports, $replacing, $first);
open(PORTS,$ports_file);
@ports=<PORTS>;
close(PORTS);
open(PORTS,">$ports_file");
for($i=0; $i<@ports; $i++) {
 chop($_ = $ports[$i]); s/;.*$//g; s/#.*$//g;
 if (/^\s*\[([^\]]+)\]/) {
  $first = 1;
  if ($replacing) {$replacing = 0;}
  elsif ($1 eq $_[0]) {
   print PORTS "[$_[1]]\n";
   foreach $k (grep {!/portname/} (keys %port)) {
    print PORTS "$k = $port{$k}\n";
    }
   print PORTS "\n";
   $replacing=1;
   }
  }
 elsif (!$first && /^\s*([^=]*\S)\s*=\s*(.*)$/ && $_[0] eq "admin") {
  $first = 1;
  print CONF "[$_[1]]\n";
  foreach $k (grep {!/portname/} (keys %port)) {
   print PORTS "$k = $port{$k}\n";
   }
  print PORTS "\n";
  $replacing = 1;
  }
 if (!$replacing) { print PORTS $ports[$i]; }
 }
close(PORTS);
}

# DeletePort
# Removes a port from the ports file
sub DeletePort
{
 local($_, @ports, $deleting);

 &GetPort("admin");
 $adminuser=&ReadValue("user");

 if (!($ENV{REMOTE_USER} eq $adminuser)) {
  &SendHeader();
  print "Error: Access denied.\n";
  return;
 }

 open(PORTS,$ports_file);
 @ports=<PORTS>;
 close(PORTS);

 @keys = split(/,/, $in{keys});
 foreach $key (@keys) {
  if ($in{$key}) {
   $job_delete = $in{$key};
   last;
  }
 }

 open(PORTS, ">$ports_file");
 for($i=0; $i<@ports; $i++) {
  chop($_ = $ports[$i]); s/;.*$//g;
  if (/^\s*\[([^\]]+)\]/) {
   if ($deleting) { $deleting = 0; }
   elsif ($job_delete eq $1) {
      print CONF "\n";
      #print "Loesche $job_delete<br>";
      $deleting = 1;
   }
  }
  if (!$deleting) { print PORTS $ports[$i]; }
 }
 close(PORTS);
 &SendRedirect("resetter.pl?action=ports");
}

# DisplayPorts()
# Displays all ports that belong to the username and password
# passed to it as a form field or as part of the URL
sub DisplayPorts
{
# &SendHeader();
 $port_id=0;
 &GetPort("admin");
 $adminuser=&ReadValue("user");
 print "<h4 align=\"center\">ICO Resetter V1.1</h4><h5 align=\"center\">You may control these jobs:</h5>";
 print "<form action=\"$ENV{SCRIPT_NAME}?action=jobs\" method=post>";
 print "<table align=center width=\"90%\">";
 print "<tr bgcolor=\"d0d0d0\"><td width=\"20%\"><b>job name</b></td><td width=\"15%\"><b>TKS ID</b></td><td width=\"65%\"><b>job description</b></td></tr>\n";
 foreach $element (&ListPorts()) {
  &GetPort($element);
  if ((&ReadValue("user") eq $ENV{REMOTE_USER}) || ($adminuser eq $ENV{REMOTE_USER})) {
   $port_id++;
   print "<tr bgcolor=\"f0f0f0\"><td>";
   if ($element ne "admin") { print "<input type=checkbox name=\"$port_id\" value=\"$element\">&nbsp;"; push(@keys,$port_id); }
   if ($element ne "admin") { print "<a href=\"$ENV{SCRIPT_NAME}?action=edit&port=$element\">$element</a></td><td>".&ReadValue("address")."</td><td>".&ReadValue("desc")."</td></tr>\n"; }
   }
  }
 if ($port_id==0) {
  print "<tr bgcolor=\"f0f0f0\"><td>&nbsp;-</td><td>&nbsp;-</td><td>&nbsp;-</td></tr></table>";
  print "</form>";
  print "<p>No jobs found.</p><p>The reason might be one or more of the following issues<ul><li>You have not been granted access to any jobs</li>\n";
  print "<li>The user name you entered was not correct</li><li>The password you entered was not correct</li></ul></p>\n";
  print "<p>For assistance please contact your provider or administrator.</p>";
  }
 else {
  print "<tr><td colspan=3><a href=\"$ENV{SCRIPT_NAME}?action=create\">Add a new job (remember to first connect the keyboard simulator!)</a></td></tr>\n" if ($ENV{REMOTE_USER} eq "admin");
  print "</table>";
  print "<input type=hidden name=keys value=\"".join(",",@keys)."\">\n";

  print "<br><table width=\"90%\" align=\"center\">";
  print "<tr><td width=\"16%\"align=\"center\"><input type=\"submit\" name=\"execute\" value=\"Execute jobs\">&nbsp;</td><td bgcolor=\"#f0f0f0\">Sends the selected jobs' keyboard data to the addresses TKS</td></tr>";
  print "<tr><td align=\"center\"><input type=\"submit\" name=\"hwreset\" value=\"Hard reset\">&nbsp;</td><td bgcolor=\"#f0f0f0\">Simulates pushing the hardware reset button on the TKD IDs given in the selected jobs</td></tr>";
  print "<tr><td align=\"center\"><input type=\"submit\" name=\"delete\" value=\"Delete jobs\">&nbsp;</td><td bgcolor=\"#f0f0f0\">Deletes all selected jobs (without confirmation!)</td></tr>";

  print "</form></table>"; 
  }
 }

# InformResetter
# Prepares and sends the command to the given Resetter
sub InformResetter
{
 local($_,$crc);
 open(PID_FILE,"</tmp/resetter.pid") or $child_pid=0;
 $child_pid=<PID_FILE>;
 close(PID_FILE);
 if ($child_pid==0 || (kill 0,$child_pid)==0 ) {
  system("./resetter-worker.pl &");
  sleep(2);
  }
 open (FIFO, "> /tmp/.resetter-fifo");
 $oldfh=select(FIFO);
 $|=1;
 select($oldfh);
 $charcount=length($_[0]);
 $hexaddress=hex($address);
 $kommando=sprintf("#TO_KBD%c%c%c%cD%s",($hexaddress>>16),(($hexaddress>>8)&0xff),($hexaddress&0xff),($charcount+4),$_[0]);
 $crc=crc($kommando);
 $kommando=sprintf("%s%c%c",$kommando,($crc >> 8),($crc & 0xff));
 $kommando_neu = $kommando . "\n" x ( 64 - length( $kommando ) );
 print FIFO $kommando_neu;
 close(FIFO);
 }

# DoReset
# Sends a HW reset signal to the given Telejet Keyboard Simulator
sub DoReset
{
 local ($_,$crc);
 open(PID_FILE,"</tmp/resetter.pid") or $child_pid=0;
 $child_pid=<PID_FILE>;
 close(PID_FILE);
 if ($child_pid==0 || (kill 0,$child_pid)==0 ) {
  system("./resetter-worker.pl &");
  sleep(2);
  }
 open (FIFO, "> /tmp/.resetter-fifo");
 $oldfh=select(FIFO);
 $|=1;
 select($oldfh);
 $charcount=length($_[0]);
 $hexaddress=hex($address);
 $kommando=sprintf("#TO_KBD%c%c%c%cR",($hexaddress>>16),(($hexaddress>>8)&0xff),($hexaddress&0xff),4);
 $crc=crc($kommando);
 $kommando=sprintf("%s%c%c",$kommando,($crc >> 8),($crc & 0xff));
 $kommando_neu = $kommando . "\n" x ( 64 - length( $kommando ) );
 print FIFO $kommando_neu;
 close(FIFO);
 }

# SendReset
# assembles the string that will initiate a HW reset on all selected
# ports and passes it forward for sending
sub SendReset
{
 local ($_);
 SendHeader();
 $did_something=0;
 &GetPort("admin");
 $adminuser=&ReadValue("user");
 @ports=split(/,/,$in{keys});
 print "<h4>Sending reset command...</h4>";
 foreach $port (@ports) {
  if (! $in{$port}) { next; }
  $did_something=1;
  print "<p>Preparing hard reset for the resetter address given in job \"$in{$port}\"...<br>";
  &GetPort($in{$port});
  $user=&ReadValue("user");
  $address=&ReadValue("address");
  if (!($ENV{REMOTE_USER} eq $user) && !($ENV{REMOTE_USER} eq $adminuser)) {
   print "Error: Access denied; you probably should not be where you are<br>\n";
   next;
   }
  DoReset($address);
  }
 if ($did_something == 0) {
  print "<h4>Error - no reset jobs selected</h4><p>Please select at least one job and try again.\n";
  }
 else {
  print "<p>All jobs have been injected into the command queue and will be sent to the Telejet Keyboard Simulator(s) as soon as possible. However, because of the asynchronous transmission you will not recieve a confirmation.";
  }
print "</p><br><a href=\"$ENV{SCRIPT_NAME}?action=ports\">Return to the port list</a>";
 }

# SendKeys
# assembles the kbd data for all selected ports and passes it to
# InformResetter in chunks of approx. 30 bytes.
sub SendKeys
{
 local ($_);
 SendHeader();
 $did_something=0;
 &GetPort("admin");
 $adminuser=&ReadValue("user");
 @ports=split(/,/,$in{keys});
 print "<h4>Sending Commands...</h4>";
 foreach $port (@ports) {
  if (! $in{$port}) { next; }
  $did_something=1;
  print "<p>Preparing job \"$in{$port}\"...<br>";
  &GetPort($in{$port});
  $user=&ReadValue("user");
  $address=&ReadValue("address");
  if (!($ENV{REMOTE_USER} eq $user) && !($ENV{REMOTE_USER} eq $adminuser)) {
   print "Error: Access denied; you probably should not be where you are<br>\n";
   next;
   }
  if (! -f "$datadir/$in{$port}.seq") {
   print "Error: Port not configured!<br>\n";
   next;
   }
  open (SEQ,"$datadir/$in{$port}.seq");
  undef $linenumber;
  while (<SEQ>) {
   $linenumber++;
   s/\n//g;
   s/\r//g;
   undef $kbd_data;
   undef @zeichenliste;
   undef $element;
   undef $crc;
   @zeichenliste=split(/ /,$_);
   $linelen=0;
   foreach $element (@zeichenliste) {
    $linelen=$linelen+1;
    if ($linelen==12) {
     $linelen=0;
     InformResetter($kbd_data,$address);
     undef($kbd_data);
     }
    if ($element =~ /\+$/) {
     $element =~ s/\+$//;
     $kbd_data=sprintf("%s%c",$kbd_data,$keytable{$element});
     }
    elsif ($element =~ /-$/) {
     $element =~ s/-$//;
     $kbd_data=sprintf("%s%c%c",$kbd_data,0xf0,$keytable{$element});
     }
    else {
     $kbd_data=sprintf("%s%c%c%c",$kbd_data,$keytable{$element},0xf0,$keytable{$element});
     }
    }
   InformResetter($kbd_data,$address);
   undef $result;
   }
  close SEQ;
  }
 if ($did_something == 0) {
  print "<h4>Error - no jobs selected</h4><p>Please select at least one job to execute and try again.\n";
  }
 else {
  print "<p>All Jobs have been placed in the command queue and will be executed as soon as possible. You will not recieve a completion confirmation because of the asynchonous protocol.\n";
  }
 print "</p><br><a href=\"$ENV{SCRIPT_NAME}?action=ports\">Return to the port list</a>";
 }

# EditPort
# Displays a form that allows the user to edit a port's properties
sub EditPort
{
 &SendHeader();
 &GetPort("admin");
 $adminuser=&ReadValue("user");
 &GetPort($in{port});
 $user=&ReadValue("user");
 $address=&ReadValue("address");
 $desc=&ReadValue("desc");
 $cmdfile="$datadir/$in{port}.seq";
 open (CMD,$cmdfile);
 read CMD,$kbd_data,1000;
 close (CMD);
 if (!($ENV{REMOTE_USER} eq $user) && !($ENV{REMOTE_USER} eq $adminuser)) {
  print "Error: Access denied.\n";
  return;
  }
 print "<h4>Edit job $in{port}</h4>\n";
 print "<form action=\"$ENV{SCRIPT_NAME}?action=save\" method=post>";
 print "<input type=hidden name=port value=\"$in{port}\">\n";
 print "<table width=\"67%\">";
 print "<tr><td width=\"30%\" bgcolor=#d0d0d0>Job name</td>";
 print "<td width=\"70%\" bgcolor=#f0f0f0><input type=text size=60 maxlength=20 name=newport value=\"$in{port}\"></td></tr>\n";
 print "<tr><td bgcolor=#d0d0d0>TKS address</td>\n";
 print "<td bgcolor=#f0f0f0><input type=text size=60 maxlength=6 name=newaddress value=\"$address\"></td></tr>\n";
 print "<tr><td bgcolor=#d0d0d0>Description</td>\n";
 print "<td bgcolor=#f0f0f0><input type=text size=60 maxlength=70 name=newdesc value=\"$desc\"></td></tr>\n";

 if ($ENV{REMOTE_USER} eq $adminuser) {
 	print "<tr><td bgcolor=#d0d0d0>User name</td>\n";
	 print "<td bgcolor=#f0f0f0><input type=text size=60 maxlength=20 name=newuser value=\"$user\"></td></tr>";
 }

# print "<tr><td bgcolor=#d0d0d0>Password</td>\n";
# print "<td bgcolor=#f0f0f0><input type=password size=60 maxlength=20 name=newpass1></td></tr>\n";
# print "<tr><td bgcolor=#d0d0d0>Confirm Password</td>\n";
# print "<td bgcolor=#f0f0f0><input type=password size=60 maxlength=20 name=newpass2></td></tr>\n";
 print "<tr><td bgcolor=#d0d0d0>Keyboard data</td>\n";
 print "<td bgcolor=#f0f0f0><textarea name=kbd_data cols=60 rows=10>$kbd_data</textarea></td></tr></table>";
 print "<table width=\"67%\">";
 print "<tr><td align=left><input type=submit name=save value=\"Save changes\"></td>\n";
 print "<td align=center><a href=\"../resetter-codes.html\" target=\"_blank\">HELP</a></td>\n";
 print "<td align=right><input type=reset name=reset value=\"Reset data\"></td></tr>";
 print "</table></form><br>";
 }

# SaveData
# Called after editing a port; saves the port data
sub SaveData
{
 &SendHeader();
 if (($in{port} ne $in{newport}) && (&GetPort($in{newport}))) {
  print "Error: The new port name is already in use by a different user.\n";
  }
 if (($in{newport} =~ / /) || ($in{port} =~ / /)) {
  print "Error: Please do not use spaces in the port name! That would cause troubles with a few browsers\n";
  return;
  }
 if ($in{new}) {
  AddPort($in{newport});
  $in{port}=$in{newport};
  }
 &GetPort("admin");
 $adminuser=&ReadValue("user");
 &GetPort($in{port});
 $user=&ReadValue("user");
 if (!($ENV{REMOTE_USER} eq $user) && !($ENV{REMOTE_USER} eq $adminuser)) {
  print "Error: Access denied.\n";
  return;
  }
 if ($in{newpass1} ne $in{newpass2}) {
  print "Error: The Passwords do not match. Use the BACK Button to try again.\n";
  return;
  }
 &WriteValue("address",$in{newaddress}) if (($in{port} ne "admin") && ($ENV{REMOTE_USER} eq $adminuser));
 &WriteValue("desc",$in{newdesc});
 &WriteValue("user",$in{newuser}) if (($adminuser eq $ENV{REMOTE_USER}) && ($in{port} ne "admin"));
 &change_passwd($user, $in{newpass1}, $in{newpass2}) if ($in{newpass1} ne "");

 &ChangePort($in{port},$in{newport});
 open (SEQ,">$datadir/$in{port}.seq") or die "Error: Could not write to config file (tried $datadir/$in{port}.seq).";
 print SEQ $in{kbd_data};
 close(SEQ);
 if ((!$in{new}) && ($in{port} ne $in{newport})) {
  rename ("$datadir/$in{port}.seq","$datadir/$in{newport}.seq");
  }
 DisplayPorts();
 }

# CreatePort
# Displays a form that allow the admin to enter data for a new port
sub CreatePort
{
 &SendHeader();
 &GetPort("admin");
 $adminuser=&ReadValue("user");
 if ($ENV{REMOTE_USER} ne $adminuser) {
  print "Error: Access denied.\n";
  return;
  }
 print "<h4>Create a new resetter port</h4>\n";
 print "<form action=\"$ENV{SCRIPT_NAME}?action=save\" method=post>";
 print "<input type=hidden name=new value=\"yes\">\n";
 print "<table width=\"67%\">";
 print "<tr><td width=\"30%\" bgcolor=#d0d0d0>Job name</td>";
 print "<td width=\"70%\" bgcolor=#f0f0f0><input type=text size=60 maxlength=20 name=newport></td></tr>\n";
 print "<tr><td bgcolor=#d0d0d0>Job address</td>\n";
 print "<td bgcolor=#f0f0f0><input type=text size=60 maxlength=6 name=newaddress></td></tr>\n";
 print "<tr><td bgcolor=#d0d0d0>Description</td>\n";
 print "<td bgcolor=#f0f0f0><input type=text size=60 maxlength=70 name=newdesc></td></tr>\n";
 print "<tr><td bgcolor=#d0d0d0>User name</td>\n";
 print "<td bgcolor=#f0f0f0><input type=text size=60 maxlength=20 name=newuser></td></tr>";
# print "<tr><td bgcolor=#d0d0d0>Password</td>\n";
# print "<td bgcolor=#f0f0f0><input type=password size=60 maxlength=20 name=newpass1></td></tr>\n";
# print "<tr><td bgcolor=#d0d0d0>Confirm Password</td>\n";
# print "<td bgcolor=#f0f0f0><input type=password size=60 maxlength=20 name=newpass2></td></tr>\n";
 print "<tr><td bgcolor=#d0d0d0>Keyboard data</td>\n";
 print "<td bgcolor=#f0f0f0><textarea name=kbd_data cols=60 rows=10>$kbd_data</textarea></td></tr>";
 print "<tr><td align=left><input type=submit name=save value=\"Save changes\"></td>\n";
 print "<td align=right><input type=reset name=reset value=\"Reset data\"></td></tr>";
 print "</table></form><br>";
 }


sub change_passwd {
 local ($user, $newpass, $confirmpass) = @_;

 # passwords mismatch
 return FALSE if ($newpass ne $confirmpass);

 system($htpasswd." -b $auth_user_file $user $newpass");
}

# crc
# calculates and returns a CRC 16 checksum over a given string
sub crc {
 local($_);
 %crc_table = (
  0 =>  0x0000,
  1 =>  0xcc01,
  2 =>  0xd801,
  3 =>  0x1400,
  4 =>  0xf001,
  5 =>  0x3c00,
  6 =>  0x2800,
  7 =>  0xe401,
  8 =>  0xa001,
  9 =>  0x6c00,
  10 => 0x7800,
  11 => 0xb401,
  12 => 0x5000,
  13 => 0x9c01,
  14 => 0x8801,
  15 => 0x4400, );

 undef($crc16_word);
 $kommando=$_[0];
 @char_list=split(/ */,$kommando);
 for (my $counter = 0; $counter < length($kommando); $counter++) {
  $zeichen = ord(substr($kommando, $counter, 1));
  $data = $zeichen;
  $r1_word = $crc_table{$crc16_word & 0x0f};
  $crc16_word = ($crc16_word >> 4) & 0x0fff;
  $crc16_word = $crc16_word ^ $r1_word ^ $crc_table{$data & 0x0f};
  $r1_word = $crc_table{$crc16_word & 0x0f};
  $crc16_word = ($crc16_word >> 4) & 0x0fff;
  $crc16_word = $crc16_word ^ $r1_word ^ $crc_table{$data >> 4};
  }
 return($crc16_word);
 }
